﻿using System;

namespace PartialFraction
{
    public class PartialFraction
    {
        public double[] expander;
        public double[] enumerator;
        public double[] denominator;
        public POLETYPE type;
        public int parent;
        public int power;
        public double[] multiplier;

        public PartialFraction(int size)
        {
            expander = new double[size];    // polynomial to expand each other polynomial
            denominator = new double[size]; // denominator polynomial
            enumerator = new double[1];     // enumerator polynomial
            enumerator[0] = 1;
            multiplier = new double[1];     // polynomial to multiply multiple and complex poles
            multiplier[0] = 1;
            type = POLETYPE.Single;
            parent = -1;
            power = 1;
        }

        public void InitExpander(double[] source)
        {
            CopyPoly(source, ref expander);
        }

        public void InitDenominator(double[] source)
        {
            CopyPoly(source, ref denominator);
        }

        private void CopyPoly(double[] source, ref double[] dest)
        {
            int i;
            Array.Resize(ref dest, source.Length);
            for (i = 0; i < dest.Length; i++)
            {
                dest[i] = source[i];
            }
        }
    }
}
